package com.example.pjsipsdktest;

import java.util.Timer;
import java.util.TimerTask;

import com.example.pjsipsdktest.R;

import android.app.Activity;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;

import com.csipsimple.api.SipCallSession;
import com.csipsimple.service.SipService.SameThreadException;

public class CallActivity extends Activity{

	 TextView tvPeer;
	 TextView tvState;
	 int second = 0;
	
	@Override
	public void onCreate(Bundle b){
		super.onCreate(b);
	
		setContentView(R.layout.call_activity);
		
		initView();
	}

	private void initView() {
		tvPeer  = (TextView) findViewById(R.id.textViewPeer);
		tvState = (TextView) findViewById(R.id.textViewCallState);
		Button buttonHangup = (Button) findViewById(R.id.buttonHangup);
		final Button buttonAccept = (Button) findViewById(R.id.buttonAccept);

//		buttonAccept.setVisibility(View.GONE);
		if(!this.getIntent().getBooleanExtra("INCOMINGCALL", true)) {
			buttonAccept.setVisibility(View.GONE);
			buttonHangup.setText("Hang Up");
		} else {
			String from = this.getIntent().getStringExtra("FROM");
			tvPeer.setText(from);
		}
		
		buttonHangup.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub
				if(!CallActivity.this.getIntent().getBooleanExtra("INCOMINGCALL", true)) {
					try {
						TestActivity.sipService.callHangup(TestActivity.toCallId[0],SipCallSession.StatusCode.DECLINE);
						finish();
					} catch (SameThreadException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				} else {
					try {
						TestActivity.sipService.callHangup(TestActivity.callIds,SipCallSession.StatusCode.DECLINE);
						finish();
					} catch (SameThreadException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				
			}
		});
		
		buttonAccept.setOnClickListener(new View.OnClickListener() {
			
			@Override
			public void onClick(View v) {
				// TODO Auto-generated method stub			
				try {
					TestActivity.sipService.callHangup(TestActivity.callIds,SipCallSession.StatusCode.ACCEPTED);
				} catch (SameThreadException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				
				buttonAccept.setVisibility(View.GONE);
				
			}
		});
		
	
		Timer timer=new Timer();
		timer.schedule(new TimerTask() {
			
			@Override
			public void run() {
				handler.post(new Runnable() {
					@Override
					public void run() {
						handler.sendEmptyMessage(0);	
						if("confirmed...".equals(TestActivity.state)) {
							second ++;
						}						
					}
				});
			}
		}, 0,1000);
		
	}
	
	private Handler handler=new Handler(){
		@Override
		public void handleMessage(Message msg){
			switch(msg.what) {
			case 0:
				tvPeer.setText(TestActivity.toCall);
				if("confirmed...".equals(TestActivity.state)) {
					tvState.setText(second + "");
				} else {
					tvState.setText(TestActivity.state);
				}
				
				if("disconnected...".equals(TestActivity.state)) {
					finish();
					TestActivity.state = "";
				}
				
				break;
			default:
				break;
			}
		}
	};
}
